import "../../../src/components/VResponsive/VResponsive.sass"; // Mixins

import Measurable from '../../mixins/measurable'; // Utilities

import mixins from '../../util/mixins';
import { convertToUnit } from '../../util/helpers';
/* @vue/component */

export default mixins(Measurable).extend({
  name: 'v-responsive',
  props: {
    aspectRatio: [String, Number]
  },
  computed: {
    __cachedSizer() {
      if (!this.sizerAspectStyle) return [];
      return this.$createElement('div', {
        style: this.sizerAspectStyle,
        staticClass: 'v-responsive__sizer'
      });
    },

    computedAspectRatio() {
      const aspectRatio = Number(this.aspectRatio);
      return !isNaN(aspectRatio) ? 1 / aspectRatio : undefined;
    },

    computedAspectRatioPercent() {
      if (this.computedAspectRatio == null) return undefined;
      return this.computedAspectRatio * 100;
    },

    sizerAspectStyle() {
      if (this.computedAspectRatioPercent == null) return undefined;
      return {
        paddingBottom: convertToUnit(this.computedAspectRatioPercent, '%')
      };
    }

  },
  methods: {
    genContent() {
      return this.$createElement('div', {
        staticClass: 'v-responsive__content'
      }, this.$slots.default);
    }

  },

  render(h) {
    return h('div', {
      staticClass: 'v-responsive',
      style: this.measurableStyles,
      on: this.$listeners
    }, [this.__cachedSizer, this.genContent()]);
  }

});
//# sourceMappingURL=VResponsive.js.map